ARG NGINX_VERSION="1.20.0"

FROM nginx:${NGINX_VERSION}-alpine as build_modsecurity
LABEL maintainer="SLot <slotmg@protonmail.com>"
ARG MODSEC_BRANCH=v3.0.5
ARG OWASP_BRANCH=v3.2/master
WORKDIR /opt

RUN \
    echo "=> Instalando base" && \
    apk add --no-cache --virtual general-dependencies autoconf automake byacc curl-dev flex g++ gcc geoip-dev git libc-dev libmaxminddb-dev libstdc++ libtool libxml2-dev linux-headers lmdb-dev make openssl-dev pcre-dev wget yajl-dev zlib-dev 

RUN \
    echo "=> MODSEC" && \
    git clone -b ${MODSEC_BRANCH} --depth 1 https://github.com/SpiderLabs/ModSecurity && \
    git -C /opt/ModSecurity submodule update --init --recursive && \
    (cd "/opt/ModSecurity" && ./build.sh && ./configure --with-lmdb && make && make install ) && \
    rm -fr /opt/ModSecurity /usr/local/modsecurity/lib/libmodsecurity.a /usr/local/modsecurity/lib/libmodsecurity.la

RUN \
    echo "=> MODSEC-NGINX" && \
    git clone -b master --depth 1 https://github.com/SpiderLabs/ModSecurity-nginx.git && \
    wget -O - https://nginx.org/download/nginx-$NGINX_VERSION.tar.gz | tar -xz 

RUN \
    echo "=> NGINX-MODULES" && \
    (cd "/opt/nginx-$NGINX_VERSION" && ./configure --with-compat --add-dynamic-module=../ModSecurity-nginx && make modules ) && \
    cp /opt/nginx-$NGINX_VERSION/objs/ngx_http_modsecurity_module.so /usr/lib/nginx/modules/ && \
    rm -fr /opt/* && \
    apk del general-dependencies


FROM nginx:${NGINX_VERSION}-alpine
LABEL maintainer="SLot <slotmg@protonmail.com>"

COPY --from=build_modsecurity /etc/nginx/ /etc/nginx/
COPY --from=build_modsecurity /usr/local/modsecurity /usr/local/modsecurity
COPY --from=build_modsecurity /usr/lib/nginx/modules/ /usr/lib/nginx/modules/

COPY conf/nginx/ /etc/nginx/
COPY conf/modsec/ /etc/nginx/modsec/

RUN \ 
    echo "=> Instalando BASE" && \
    apk add --no-cache curl-dev libmaxminddb-dev libstdc++ libxml2-dev lmdb-dev tzdata yajl && \
    chown -R nginx:nginx /usr/share/nginx

WORKDIR /usr/share/nginx/html

EXPOSE 80 443

